import java.util.*;
/*
* This file is part of the XKCD Velociraptor Simulation originally written by Matthew Beckler, Grant Miller, and John Saxton.
* 
* the XKCD Velociraptor Simulation is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* The XKCD Velociraptor Simulation is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with the XKCD Velociraptor Simulation; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**/

public abstract class Movable // Raptor and Victim are sub-classes of Movable
{
	protected double v; // v for velocity! (maximum velocity, that is)
	protected double x;
	protected double y;
	
	public Movable(double v, double x, double y)
	{
		this.v = v;
		this.x = x;
		this.y = y;
	}
	
	public double getX()
	{
		return x;
	}
	
	public void setX(double x)
	{
		this.x = x;
	}
	
	public double getY()
	{
		return y;
	}
	
	public void setY(double y)
	{
		this.y = y;
	}
	
	public double getV()
	{
		return v;
	}
	
	//return value indicates if this object can reach the target (only used for raptors)
	//in this method, this Movable will update its own coordinates according to the rules of the system.
	public abstract boolean updatePosition(double dt, Movable target);
}
